---
title: Xamarin.Android error XA0128
description: XA0128 error code
ms.date: 08/07/2020
---
# Xamarin.Android error XA0128

## Issue

The Fast Deployment system relys on reading the output from the various system applications
on the device. This is done by reading `System.out`, which by default is where all output
will be redirected. If `log.redirect-stdio` this will cause all of the Fast Deployment tooling
to fail.

## Solution

Disable the redirection of stdio in order to use Fast Deployment. This can be done using
the following commands.

```
adb shell stop
adb shell setprop log.redirect-stdio false
adb shell start
```

Depending on the device you might need to run `adb root` before running the above commands.