title: Xamarin.Android error XA0129
description: XA0129 error code
ms.date: 08/07/2020
---
# Xamarin.Android error XA0129

## Issue

This issue happens when you are trying to use fast deployment on a device which
does not support it. In this case both the normal and backup types of fast
deployment failed. The Fast Deployment system makes use of the
[`run-as`](https://android.googlesource.com/platform/system/core.git/+/refs/heads/master/run-as/run-as.cpp#42) feature of the Android OS. This feature was either not available or had
limited capabilities in API 20 and earlier

## Solution

Disable Fast Deployment by setting  `EmbedAssembliesIntoApk = True` in your .csproj.
Or turn off `Fast Deployment` in the IDE. You will still be able to debug on the device,
all the required files will be packaged inside the .apk.