---
title: Xamarin.Android warning XA4309
description: XA4309 warning code
ms.date: 02/11/2020
---
# Xamarin.Android warning XA4309

## Example messages

```
'MultiDexMainDexList' file 'multidexcustom.keep' does not exist.
```

## Issue

One of the specified `@(MultiDexMainDexList)` build items could not be found on
disk.

To learn more about multidex and how it relates to Android development, see the
[Android documentation][android].

## Solution

Verify that you are not declaring a `@(MultiDexMainDexList)` build item that
does not exist.

[android]: https://developer.android.com/studio/build/multidex
