---
title: Xamarin.Android error XA4310
description: XA4310 error code
ms.date: 03/09/2020
---
# Xamarin.Android warning XA4310

## Example messages

```
error XA4310: `$(AndroidSigningKeyStore)` file `filename.keystore` could not be found.
```

## Issue

The specified `$(AndroidSigningKeyStore)` file could not be located on disk.

## Solution

Check that the `$(AndroidSigningKeyStore)` MSBuild property is set to a valid
path of an existing keystore.

This property corresponds to the **Keystore** field in the **Android Package
Signing** section of the Visual Studio project property pages.
