---
title: Xamarin.Android error/warning XA4312
description: XA4312 error/warning code
ms.date: 07/07/2020
---
# Xamarin.Android error/warning XA4312

Referencing an [Android Wear][0] application project from an Android
application project is deprecated.

From a `Foo.Android.csproj` in past versions of Xamarin.Android, you
could reference a `Foo.Wear.csproj` such as:

```xml
<ProjectReference Include="..\Foo.Wear\Foo.Wear.csproj">
  <IsAppExtension>True</IsAppExtension>
</ProjectReference>
```

This would embed `com.foo.wear.apk` *inside* `com.foo.android.apk` in
`Resources/raw`.

## Solution

Distribute `Foo.Wear.csproj` in the above example as a [standalone][1]
Android Wear application instead.

[0]: https://docs.microsoft.com/xamarin/android/wear/get-started/intro-to-wear
[1]: https://developer.android.com/training/wearables/apps/standalone-apps
