## Bindings Projects: Support for Kotlin Libraries

This release adds better support for creating bindings for Kotlin libraries, including:

* Hiding Kotlin `internal` types and members
* Using Kotlin provided metadata to properly name method parameters
* Hiding Kotlin generated methods like `foo-impl` that aren't intended for public use
* Restoring Kotlin-mangled method names to their original names, such as changing `foo-V5j3Lk8` back to `foo`
* Adding support for Kotlin's native unsigned types (UInt, ULong, UShort, UByte)

Although it was technically possible to bind a Kotlin library previously, these changes
greatly reduce the number of custom rules needed in the *Transforms\\Metadata.xml* file to produce expected bindings.

No additional steps are needed to enable this.  The binding process will detect if a `.jar`
was produced from Kotlin and will apply the needed fixes.

```
Important: 

Some of these changes required adding new APIs to `Java.Interop.dll`.  This means that
like the binding projects themselves, Xamarin.Android application projects that
consume one of these new Kotlin library bindings must also be built using
Xamarin.Android 10.2 or higher.
```
