<img src="Documentation/images/banner.png" alt="Xamarin.Android banner" height="145" >

Xamarin.Android
===============

Xamarin.Android provides open-source bindings of the Android SDK for use with
.NET managed languages such as C#.

# Build Status

| Platform              | Status |
|-----------------------|--------|
| **OSS macOS**         | [![OSS macOS x86_64][oss-macOS-x86_64-icon]][oss-macOS-x86_64-status] |
| **OSS Ubuntu**        | [![OSS Linux/Ubuntu x86_64][oss-ubuntu-x86_64-icon]][oss-ubuntu-x86_64-status] |
| **OSS Windows**       | [![OSS Windows x86_64][oss-windows-x86_64-icon]][oss-windows-x86_64-status] |

[oss-macOS-x86_64-icon]: https://jenkins.mono-project.com/view/Xamarin.Android/job/xamarin-android/badge/icon
[oss-macOS-x86_64-status]: https://jenkins.mono-project.com/view/Xamarin.Android/job/xamarin-android/
[oss-ubuntu-x86_64-icon]: https://dev.azure.com/xamarin/public/_apis/build/status/Xamarin.Android-OSS?branchName=master
[oss-ubuntu-x86_64-status]: https://dev.azure.com/xamarin/public/_build/latest?definitionId=48
[oss-windows-x86_64-icon]: https://devdiv.visualstudio.com/_apis/public/build/definitions/0bdbc590-a062-4c3f-b0f6-9383f67865ee/7212/badge
[oss-windows-x86_64-status]: https://devdiv.visualstudio.com/DevDiv/Default/_build/index?definitionId=7212

# Downloads

## Current

| Platform        | Link   |
|-----------------|--------|
| **Commercial Xamarin.Android 11.1 (d16-8) Preview** for Windows+Visual Studio 2019 Preview  | [Download][commercial-d16-8-Windows-x86_64] |
| **Commercial Xamarin.Android 11.1 (d16-8) Preview** for macOS                               | [Download][commercial-d16-8-macOS-x86_64]   |
| **Commercial Xamarin.Android 11.0 (d16-7)** for Windows+Visual Studio 2019                  | [Download][commercial-d16-7-Windows-x86_64] |
| **Commercial Xamarin.Android 11.0 (d16-7)** for macOS                                       | [Download][commercial-d16-7-macOS-x86_64]   |
| **OSS Xamarin.Android 11.1.99 (master)** for Ubuntu\*                                       | [![OSS Linux/Ubuntu x86_64][oss-ubuntu-x86_64-icon]][oss-ubuntu-x86_64-status] |

*\* Please note that the OSS installer packages are not digitally signed.*

## Previous

| Platform        | Link   |
|-----------------|--------|
| **Commercial Xamarin.Android 10.3 (d16-6)** for Windows+Visual Studio 2019                  | [Download][commercial-d16-6-Windows-x86_64] |
| **Commercial Xamarin.Android 10.3 (d16-6)** for macOS                                       | [Download][commercial-d16-6-macOS-x86_64]   |
| **Commercial Xamarin.Android 10.2 (d16-5)** for Windows+Visual Studio 2019                  | [Download][commercial-d16-5-Windows-x86_64] |
| **Commercial Xamarin.Android 10.2 (d16-5)** for macOS                                       | [Download][commercial-d16-5-macOS-x86_64]   |
| **Commercial Xamarin.Android 10.1 (d16-4)** for Windows+Visual Studio 2019                  | [Download][commercial-d16-4-Windows-x86_64] |
| **Commercial Xamarin.Android 10.1 (d16-4)** for macOS                                       | [Download][commercial-d16-4-macOS-x86_64]   |
| **Commercial Xamarin.Android 10.0 (d16-3)** for Windows+Visual Studio 2019                  | [Download][commercial-d16-3-Windows-x86_64] |
| **Commercial Xamarin.Android 10.0 (d16-3)** for macOS                                       | [Download][commercial-d16-3-macOS-x86_64]   |
| **Commercial Xamarin.Android 9.4 (d16-2)** for Windows+Visual Studio 2019                   | [Download][commercial-d16-2-Windows-x86_64] |
| **Commercial Xamarin.Android 9.4 (d16-2)** for macOS                                        | [Download][commercial-d16-2-macOS-x86_64]   |
| **Commercial Xamarin.Android 9.3 (d16-1)** for Windows+Visual Studio 2019                   | [Download][commercial-d16-1-Windows-x86_64] |
| **Commercial Xamarin.Android 9.3 (d16-1)** for macOS                                        | [Download][commercial-d16-1-macOS-x86_64]   |
| **Commercial Xamarin.Android 9.2 (d16-0)** for Windows+Visual Studio 2019                   | [Download][commercial-d16-0-Windows-x86_64] |
| **Commercial Xamarin.Android 9.2 (d16-0)** for macOS                                        | [Download][commercial-d16-0-macOS-x86_64]   |
| **Commercial Xamarin.Android 9.1 (d15-9)** for macOS &amp; Windows+Visual Studio 2017       | [![Commercial Xamarin.Android 9.1, macOS+VS2017][commercial-d15-9-macOS-x86_64-icon]][commercial-d15-9-macOS-x86_64-status] |
| **Commercial Xamarin.Android 9.0 (d15-8)** for macOS &amp; Windows+Visual Studio 2017       | [![Commercial Xamarin.Android 9.0, macOS+VS2017][commercial-d15-8-macOS-x86_64-icon]][commercial-d15-8-macOS-x86_64-status] |

[commercial-d15-8-macOS-x86_64-icon]:     https://jenkins.mono-project.com/view/Xamarin.Android/job/xamarin-android-builds-d15-8/badge/icon
[commercial-d15-8-macOS-x86_64-status]:   https://jenkins.mono-project.com/view/Xamarin.Android/job/xamarin-android-builds-d15-8/
[commercial-d15-9-macOS-x86_64-icon]:     https://jenkins.mono-project.com/view/Xamarin.Android/job/xamarin-android-builds-d15-9/badge/icon
[commercial-d15-9-macOS-x86_64-status]:   https://jenkins.mono-project.com/view/Xamarin.Android/job/xamarin-android-builds-d15-9/
[commercial-d16-0-Windows-x86_64]:        https://aka.ms/xamarin-android-commercial-d16-0-windows
[commercial-d16-0-macOS-x86_64]:          https://aka.ms/xamarin-android-commercial-d16-0-macos
[commercial-d16-1-Windows-x86_64]:        https://aka.ms/xamarin-android-commercial-d16-1-windows
[commercial-d16-1-macOS-x86_64]:          https://aka.ms/xamarin-android-commercial-d16-1-macos
[commercial-d16-2-Windows-x86_64]:        https://aka.ms/xamarin-android-commercial-d16-2-windows
[commercial-d16-2-macOS-x86_64]:          https://aka.ms/xamarin-android-commercial-d16-2-macos
[commercial-d16-3-Windows-x86_64]:        https://aka.ms/xamarin-android-commercial-d16-3-windows
[commercial-d16-3-macOS-x86_64]:          https://aka.ms/xamarin-android-commercial-d16-3-macos
[commercial-d16-4-Windows-x86_64]:        https://aka.ms/xamarin-android-commercial-d16-4-windows
[commercial-d16-4-macOS-x86_64]:          https://aka.ms/xamarin-android-commercial-d16-4-macos
[commercial-d16-5-Windows-x86_64]:        https://aka.ms/xamarin-android-commercial-d16-5-windows
[commercial-d16-5-macOS-x86_64]:          https://aka.ms/xamarin-android-commercial-d16-5-macos
[commercial-d16-6-Windows-x86_64]:        https://aka.ms/xamarin-android-commercial-d16-6-windows
[commercial-d16-6-macOS-x86_64]:          https://aka.ms/xamarin-android-commercial-d16-6-macos
[commercial-d16-7-Windows-x86_64]:        https://aka.ms/xamarin-android-commercial-d16-7-windows
[commercial-d16-7-macOS-x86_64]:          https://aka.ms/xamarin-android-commercial-d16-7-macos
[commercial-d16-8-Windows-x86_64]:        https://aka.ms/xamarin-android-commercial-d16-8-windows
[commercial-d16-8-macOS-x86_64]:          https://aka.ms/xamarin-android-commercial-d16-8-macos

# Contributing

If you are interested in fixing issues and contributing directly to the code base, please see the following:

  - [How to build and run from source](Documentation/README.md#building-from-source)
  - [The development workflow, and using your build](Documentation/README.md#development-workflow)
  - [Coding Guidelines](http://www.mono-project.com/community/contributing/coding-guidelines/)
  - [Submitting pull requests](https://github.com/xamarin/xamarin-android/wiki/Submitting-Bugs,-Feature-Requests,-and-Pull-Requests#pull-requests)

This project has adopted the code of conduct defined by the Contributor Covenant
to clarify expected behavior in our community. For more information, see the
[.NET Foundation Code of Conduct](http://www.dotnetfoundation.org/code-of-conduct).

# Feedback

  - Ask a question on [Stack Overflow](https://stackoverflow.com/questions/tagged/xamarin.android) or the [Xamarin Forums](https://forums.xamarin.com/categories/android).
  - [Request a new feature](https://github.com/xamarin/xamarin-android/wiki/Submitting-Bugs,-Feature-Requests,-and-Pull-Requests) on GitHub.
  - [Vote for popular feature requests](https://github.com/xamarin/xamarin-android/issues?utf8=%E2%9C%93&q=is%3Aissue+is%3Aopen+label%3Aenhancement+sort%3Areactions-%2B1-desc).
  - File an issue in [GitHub Issues](https://github.com/xamarin/xamarin-android/issues/new).
  - [Tweet](https://twitter.com/xamarinhq) us with other feedback.
  - Discuss development and design on [Discord](https://aka.ms/dotnet-discord) or email [android-devel@lists.xamarin.com](android-devel@lists.xamarin.com) 

[![Discord](https://img.shields.io/badge/chat-on%20discord-brightgreen)](https://aka.ms/dotnet-discord)

# License

Copyright (c) .NET Foundation Contributors. All rights reserved.
Licensed under the [MIT](LICENSE) License.
